<?php

if ( ! function_exists( 'sante_set_404_page_inner_classes' ) ) {
	/**
	 * Function that return classes for the page inner div from header.php
	 *
	 * @param string $classes
	 *
	 * @return string
	 */
	function sante_set_404_page_inner_classes( $classes ) {
		
		if ( is_404() ) {
			$classes = 'qodef-content-full-width';
		}
		
		return $classes;
	}
	
	add_filter( 'sante_filter_page_inner_classes', 'sante_set_404_page_inner_classes' );
}

if ( ! function_exists( 'sante_get_404_page_parameters' ) ) {
	/**
	 * Function that set 404 page area content parameters
	 */
	function sante_get_404_page_parameters() {
		
		$params = array(
			'title'       => esc_html__( 'Page not found', 'sante' ),
			'text'        => esc_html__( '  The page you are looking for doesn\'t exist. It may have been moved or removed altogether. Please try searching for some other page.', 'sante' ),
			'button_text' => esc_html__( 'Back to home', 'sante' ),
		);
		
		return apply_filters( 'sante_filter_404_page_template_params', $params );
	}
}
